"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  listMessages: () => listMessages2,
  sendMessage: () => sendMessage2
});
module.exports = __toCommonJS(meta_exports);

// src/crm-inbox-v2-message-messages.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressInboxV2MessagesServiceUrl(opts) {
  const domainToMappings = {
    "www.wixapis.com": [
      {
        srcPath: "/inbox/v2/messages",
        destPath: "/v2/messages"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/inbox-platform-messages",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_inbox_messages";
function listMessages(payload) {
  function __listMessages({ host }) {
    const metadata = {
      entityFqdn: "wix.crm.inbox.v2.message",
      method: "GET",
      methodFqn: "com.wixpress.inbox.v2.MessagesService.ListMessages",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressInboxV2MessagesServiceUrl({
        protoPath: "/v2/messages",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload, true),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "messages.createdDate" }]
        }
      ])
    };
    return metadata;
  }
  return __listMessages;
}
function sendMessage(payload) {
  function __sendMessage({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "message.createdDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.crm.inbox.v2.message",
      method: "POST",
      methodFqn: "com.wixpress.inbox.v2.MessagesService.SendMessage",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressInboxV2MessagesServiceUrl({
        protoPath: "/v2/messages",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "message.createdDate" }]
        }
      ])
    };
    return metadata;
  }
  return __sendMessage;
}

// src/crm-inbox-v2-message-messages.meta.ts
function listMessages2() {
  const payload = {};
  const getRequestOptions = listMessages(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v2/messages",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function sendMessage2() {
  const payload = {};
  const getRequestOptions = sendMessage(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v2/messages",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  listMessages,
  sendMessage
});
//# sourceMappingURL=meta.js.map