// src/crm-inbox-v2-message-messages.http.ts
import { toURLSearchParams } from "@wix/sdk-runtime/rest-modules";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformRESTTimestampToSDKTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressInboxV2MessagesServiceUrl(opts) {
  const domainToMappings = {
    "www.wixapis.com": [
      {
        srcPath: "/inbox/v2/messages",
        destPath: "/v2/messages"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/inbox-platform-messages",
        destPath: ""
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_inbox_messages";
function listMessages(payload) {
  function __listMessages({ host }) {
    const metadata = {
      entityFqdn: "wix.crm.inbox.v2.message",
      method: "GET",
      methodFqn: "com.wixpress.inbox.v2.MessagesService.ListMessages",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressInboxV2MessagesServiceUrl({
        protoPath: "/v2/messages",
        data: payload,
        host
      }),
      params: toURLSearchParams(payload, true),
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "messages.createdDate" }]
        }
      ])
    };
    return metadata;
  }
  return __listMessages;
}
function sendMessage(payload) {
  function __sendMessage({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [{ path: "message.createdDate" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.crm.inbox.v2.message",
      method: "POST",
      methodFqn: "com.wixpress.inbox.v2.MessagesService.SendMessage",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressInboxV2MessagesServiceUrl({
        protoPath: "/v2/messages",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => transformPaths(payload2, [
        {
          transformFn: transformRESTTimestampToSDKTimestamp,
          paths: [{ path: "message.createdDate" }]
        }
      ])
    };
    return metadata;
  }
  return __sendMessage;
}

// src/crm-inbox-v2-message-messages.meta.ts
function listMessages2() {
  const payload = {};
  const getRequestOptions = listMessages(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v2/messages",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function sendMessage2() {
  const payload = {};
  const getRequestOptions = sendMessage(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v2/messages",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
export {
  listMessages2 as listMessages,
  sendMessage2 as sendMessage
};
//# sourceMappingURL=meta.mjs.map